# -*- coding: utf-8 -*-
"""
Created on Sat Apr 10 20:40:08 2021

@author: Quique, adapted from suhemparack (Twitter Staff) 
at https://twittercommunity.com/t/how-to-overcome-the-limit-of-500-posts-with-an-approved-project/149481/2
"""

import requests
import json
import time
import glob
def connect_to_endpoint(bearer_token, my_query, next_token):  
    headers = {"Authorization": "Bearer {}".format(bearer_token)}
    
    # add additional parameters as needed
    params = {"tweet.fields" : "author_id,created_at,attachments,entities,public_metrics,geo,source", "expansions" : "attachments.media_keys,entities.mentions.username", "media.fields" : "url,public_metrics,type", "user.fields" : "username,public_metrics"}
       
    # replace appropriate start and end times below
    if (next_token is not None):
        url = "https://api.twitter.com/2/tweets/search/all?query={}&max_results=50&start_time={}&end_time={}&next_token={}".format(my_query, start_time, end_time, next_token)
    else:
        url = "https://api.twitter.com/2/tweets/search/all?query={}&max_results=50&start_time={}&end_time={}".format(my_query, start_time, end_time)
    
    time.sleep(20)
    response = requests.request("GET", url, params=params, headers=headers)
    
    if response.status_code == 429:
        time.sleep(20)
        print('waiting')
    if response.status_code != 200 and response.status_code != 429:
        raise Exception(response.status_code, response.text)
    
    return response.json()

count = 0
page = 0
flag = True
# Replace with your own bearer token from your academic project in developer portal
bearer_token = input("Enter your Bearer Token: ")

# add your customised query
my_query = "url:google.com/patents/about?id -is:retweet"
start_time = "2006-03-26T01:00:00Z"
end_time = "2019-12-31T23:59:59Z"
next_token=None

# first iteration obtaining the first page of results and getting the next token from results
while flag:
    json_response = connect_to_endpoint(bearer_token, my_query, next_token)
    p1 = json_response['data']
    with open('c:/users/quique/downloads/test/tweets.json', 'w', newline='', encoding='utf-8') as f1:
        json.dump(p1, f1, indent=4)
    f1.close()
    result_count = json_response['meta']['result_count']
    for serp in json_response['data']:
        page= page+1
        print(page)
    flag = False

# all the remaining iterations, until no 'next token' exists    
while 'next_token' in json_response['meta']:
    next_token = json_response['meta']['next_token']
    if result_count is not None and result_count > 0 and next_token is not None:
        time.sleep(20)
        json_response = connect_to_endpoint(bearer_token, my_query, next_token)
        for serp in json_response['data']:
            page= page+1
            print(page)
        p2 = json_response['data']
        count=count+1
        address= "c:/users/quique/downloads/test/"+str(count)+".json"
        with open(address, 'a+', newline='', encoding='utf-8') as f2:
            json.dump(p2, f2, indent=4)
        f2.close()

    else:
        print('Iteration finished')

# joining json obtained into one file in final.csv
glob_data = []
for file in glob.glob('c:/users/quique/downloads/test/*.json'):
    with open(file) as json_file:
        data = json.load(json_file)

        i = 0
        while i < len(data):
            glob_data.append(data[i])
            i += 1
with open('c:/users/quique/downloads/test/final.json', 'w') as f:
    json.dump(glob_data, f, indent=4)
    
print(f'Total pages saved: {page}')
